#define export __declspec (dllexport)
#include <windows.h>

export double reg_del_val(double hkey, char *key, char *val) {
 HKEY hk;
 LONG lr;
 switch ((int) hkey) {
  case 0: hk = HKEY_CURRENT_USER; break;
  case 1: hk = HKEY_LOCAL_MACHINE; break;
  case 2: hk = HKEY_CLASSES_ROOT; break;
  case 3: hk = HKEY_USERS; break;
	default: return -1;
 }
 lr = RegOpenKeyEx(hk,key,0,KEY_SET_VALUE,&hk);
 if (lr == ERROR_FILE_NOT_FOUND) return 1;
 else if (lr != ERROR_SUCCESS) return -2;
 lr = RegDeleteValue(hk,val);
 if (lr == ERROR_SUCCESS) return 0;
 else if (lr == ERROR_FILE_NOT_FOUND) return 2;
 return -2;
}

export double reg_del_key(double hkey, char *key) {
 HKEY hk;
 LONG lr;
 switch ((int) hkey) {
  case 0: hk = HKEY_CURRENT_USER; break;
  case 1: hk = HKEY_LOCAL_MACHINE; break;
  case 2: hk = HKEY_CLASSES_ROOT; break;
  case 3: hk = HKEY_USERS; break;
	default: return -1;
 }
 lr = RegDeleteKey(hk,key);
 if (lr == ERROR_SUCCESS) return 0;
 else if (lr == ERROR_FILE_NOT_FOUND) return 1;
 return -2;
}

char rs[16];

export char* getMod(char *f)
{
	HANDLE h;
	FILETIME ft;
	SYSTEMTIME st;
	h = CreateFile(f,GENERIC_READ,FILE_SHARE_READ,
		NULL,OPEN_EXISTING,FILE_FLAG_BACKUP_SEMANTICS,NULL);
	if (h == INVALID_HANDLE_VALUE) return "";
	if (!GetFileTime(h,NULL,NULL,&ft))
	{
		CloseHandle(h);
		return "";
	}
	CloseHandle(h);
	FileTimeToSystemTime(&ft, &st);
	sprintf(rs,"%u%02u%02uT%02u%02u%02uZ",st.wYear,st.wMonth,st.wDay,st.wHour,st.wMinute,st.wSecond);
	return rs;
}

export double setMod(char *f, char *t)
{
	HANDLE h;
	FILETIME ft;
	SYSTEMTIME st;
	int r1,r2,r3,r4,r5,r6;
	h = CreateFile(f,GENERIC_WRITE,FILE_SHARE_WRITE,
		NULL,OPEN_EXISTING,FILE_FLAG_BACKUP_SEMANTICS,NULL);
	if (h == INVALID_HANDLE_VALUE) return -1;
	sscanf(t,"%4i%2i%2iT%2i%2i%2iZ",&r1,&r2,&r3,&r4,&r5,&r6);
	st.wYear = r1;
	st.wMonth = r2;
	st.wDay = r3;
	st.wHour = r4;
	st.wMinute = r5;
	st.wSecond = r6;
	SystemTimeToFileTime(&st,&ft);
	if (!SetFileTime(h,NULL,NULL,&ft))
	{
		CloseHandle(h);
		return -2;
	}
	CloseHandle(h);
	return 0;
}
