#define reg_init
//reg_init()
//initializes the dll. No arguments, no return
//Reger, by IsmAvatar. C source included.

//Registry functions have the following return values:
// 0 = Success
// 1 = Key not found
// 2 = Value not found (only when deleting a value)
//-1 = Invalid root
//-2 = Other error
//Notice: Positive returns are not necessarily an error
// E.G: if the key/value does not exist or was already deleted
// But they may also mean you typed the key/value incorrectly!

global.REGDLL = "reger.dll"
global.REG_dv = external_define(global.REGDLL,"reg_del_val",0,0,3,0,1,1)
global.REG_dk = external_define(global.REGDLL,"reg_del_key",0,0,2,0,1)
global.REG_gm = external_define(global.REGDLL,"getMod",0,1,1,1)
global.REG_sm = external_define(global.REGDLL,"setMod",0,0,2,1,1)
#define reg_kill
//reg_kill()
//frees the dll from memory. No arguments, no return

external_free(global.REGDLL)
#define reg_dv
//er = reg_dv(root,key,value)
//Deletes a value from the registry.
//Arguments:
// root is defined in the manual (a number)
// key is the directory, subkeys are delimited by backslashes (\)
//  Do not begin or end with a backslash
//  Good: "Software\test", Bad: "\Software\test", Bad: "Software\test\"
// value is the entry you wish to delete
//Returns 0 on success, see reg_init.

return external_call(global.REG_dv,argument0,argument1,argument2)
#define reg_dk
//er = reg_dk(root,key)
//Deletes a key from the registry.
//The key must not have any values or subkeys.
//Arguments:
// root is defined in the manual (a number)
// key is the directory, subkeys are delimited by backslashes (\)
//  Do not begin or end with a backslash
//  Good: "Software\test", Bad: "\Software\test", Bad: "Software\test\"
//Returns 0 on success. See reg_init.

return external_call(global.REG_dk,argument0,argument1,argument2)
#define get_mod
//mod = get_mod(filename)
//Gets the Last Modified Date and Time of the given file/folder
//Date and Time is in ISO Standard

//ISO Standard:
// Date and Time is in UTC, in the format YYYYMMDDThhmmssZ
// Where "T" and "Z" are literal values (eg "20071014T002427")
// After the year 9999, another digit is added (10000)
// Month is from 1 to 12, hour is from 0 to 23

//Returns "" on error, the Date and Time on success.

return external_call(global.REG_gm,argument0)
#define set_mod
//mod = set_mod(filename,dateTimeString)
//Set the Last Modified Date and Time of the given file/folder
//Date and Time must be ISO standard

//ISO Standard:
// Date and Time is in UTC, in the format YYYYMMDDThhmmssZ
// Where "T" and "Z" are literal values (eg "20071014T002427")
// After the year 9999, add another digit (10000)
// Month is from 1 to 12, hour is from 0 to 23
// Milliseconds and Weekday are not permitted (unnecessary)

//Returns:
// 0 on Success
//-1 if the file has problems
//-2 if the dateTime has problems.

return external_call(global.REG_sm,argument0,argument1)
